#lang racket

(define ccstack '())
(define (fail)
  (if (null? ccstack)
      (error 'no-solution)
      (let ([next-cc (car ccstack)])
        (set! ccstack (cdr ccstack))
        (next-cc next-cc))))

(define (amb lst)
  (let ([cc (call/cc (lambda (u) (u u)))])
    (if (null? lst)
        (fail)
        (let ([head (car lst)])
          (set! lst (cdr lst))
          (set! ccstack (cons cc ccstack))
          head))))

(define (assert t)
  (if (not t)
      (fail)
      #t))


(let ([a (amb '(1 2 3 4 5 6))]
      [b (amb '(1 2 3 4 5 6))]
      [c (amb '(1 2 3 4 5 6))])
  
  ;(pretty-print `(trying ,a ,b ,c))
  (assert (= (+ (* a a) (* b b)) (* c c)))

  (pretty-print `(solution ,a ,b ,c)))

